%.o: %.c
	$(CC) -c $(CFLAGS) -I$(HPATH) -o $@ $<
	if ! [ -f "$@" ]; then \
		if [ -f "$(*F).rel" ]; then \
			ln -- "$(*F).rel" "$@"; \
			exit 0; \
		fi; \
		echo "broken CC"; \
		exit 1; \
	fi

%.rel: %.c
	$(CC) -c $(CFLAGS) -I$(HPATH) -o $@ $<

%.check: %.c
	$(SPARSE) $(EXTRA_CFLAGS_nostdinc) -DKBUILD_BASENAME=$(subst $(comma),_,$(subst -,_,$(*F))) $(CFLAGS_$@) $(NOSTDINC_FLAGS) $<

.PHONY: default
default: $(O_TARGET) run-subdirs 

$(O_TARGET): $(obj-y)
	rm -f $@
	$(AR) -a $@ $^

run-subdirs:
	for DIR in $(subdirs-y); do \
		$(MAKE) -C "$$DIR" || exit 1; \
	done

.PHONY: check
check: $(patsubst %.o,%.check,$(obj-y))
	for DIR in $(subdirs-y); do \
		$(MAKE) -C "$$DIR" check; \
	done

.PHONY: clean
clean:
	for DIR in $(subdirs-y); do \
		$(MAKE) -C "$$DIR" clean; \
	done
	-rm -f $(obj-y) $(O_TARGET) $(clean-y)

#
# This make dependencies quickly
#
fastdep: dummy
	for DIR in $(subdirs-y); do \
		$(MAKE) -C "$$DIR" fastdep; \
	done
	$(TOPDIR)/scripts/mkdep $(CFLAGS) $(EXTRA_CFLAGS_nostdinc) -- $(wildcard *.[chS]) > .depend

dep: fastdep

#
# include dependency files if they exist
#
ifneq ($(wildcard .depend),)
include .depend
endif

.PHONY: dummy
dummy:
