/*
 * tmos - spi.h
 * 	version 0.0.0
 * 
 * Copyright (C) 2009  Marek Piwoski <marek@microster.pl>
 * Copyright (C) 2009  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef SPI_H_INCLUDED
#define SPI_H_INCLUDED

#include <tmos/kernel.h>

#ifdef CONFIG_SPI
void spi_init(void);

uint8_t spi_xmit(uint8_t c);

void spi_start(u8 c) __reentrant;
u8 spi_send(u8 c) __reentrant;
u8 spi_stop(void) __reentrant;

#else
#define spi_init()	do { } while (0)

#define spi_xmit(c)	(c)

#define spi_start(c)	do { (void) (c); } while (0)
#define spi_send(c)	(c)
#define spi_stop()	(0)
#endif

#endif
