/*
 * tmos - tfork.c
 *
 * Copyright (C) 2011  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/sched.h>
#include <tmos/kernel.h>
#include <tmos/errno.h>

/**
 * __tfork - tfork() helper routine
 * 
 * This routine is helper routine used by tfork() implementation.
 */
char __tfork(void) __reentrant
{
	register pid_t pid;

	pid = pid_alloc();
	if (pid < 0)
		return pid;

	preempt_disable();
	wake_up_context(&task[pid]);
	return pid;
}
